// Code generated by goderive DO NOT EDIT.

package main

// deriveEqualComplexStruct returns whether this and that are equal.
func deriveEqualComplexStruct(this, that *ComplexStruct) bool {
	return (this == nil && that == nil) ||
		this != nil && that != nil &&
			this.Int == that.Int &&
			deriveEqual(&this.MyStruct, &that.MyStruct) &&
			deriveEqual_(&this.Anon, &that.Anon)
}

// deriveEqual returns whether this and that are equal.
func deriveEqual(this, that *MyStruct) bool {
	return (this == nil && that == nil) ||
		this != nil && that != nil &&
			this.Int64 == that.Int64 &&
			((this.StringPtr == nil && that.StringPtr == nil) || (this.StringPtr != nil && that.StringPtr != nil && *(this.StringPtr) == *(that.StringPtr)))
}

// deriveEqual_ returns whether this and that are equal.
func deriveEqual_(this, that *Anon) bool {
	return (this == nil && that == nil) ||
		this != nil && that != nil &&
			deriveEqual_1(&this.Nested, &that.Nested)
}

// deriveEqual_1 returns whether this and that are equal.
func deriveEqual_1(this, that *Nested) bool {
	return (this == nil && that == nil) ||
		this != nil && that != nil &&
			deriveEqual(&this.MyStruct, &that.MyStruct)
}
